/*
 * Copyright (c) 2000, 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Clack.
 * 
 * Clack is free software, also known as "open source."  You can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * (GPL), version 2, as published by the Free Software Foundation (FSF).
 * 
 * Clack is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with Clack; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 * 
 * Clack is modelled on and includes some code fragments from MIT's Click
 * system (http://www.pdos.lcs.mit.edu/click/) which is copyright (c)
 * 1999-2000 Massachusetts Institute of Technology and also GPL'ed.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

#include <stdio.h>
#include <stdarg.h>

void knit_progress(const char* what, int rc)
{
        printf("initializer %s returned exit code 0x%x\n", what, rc);
}

/*
 * This is supposed to be part of the standard library - but it 
 * doesn't seem to be there...
 */
void panic(const char *fmt, ...)
{
	va_list vl;

	va_start(vl, fmt);
	vprintf(fmt, vl);
	va_end(vl);

	printf("\n");
	exit(1);
}

extern int knit_main(int argc, char* argv[]);

int main(int argc, char* argv[])
{
        int rc;
	if ((rc = knit_init())) exit(rc);
        if ((rc = knit_main(argc,argv))) exit(rc);
        // note that finalizers aren't run if we exit before here.
        // C'est la vie.
	if ((rc = knit_fini())) exit(rc);
        exit(0);
}

